apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  name: ingressroutes.traefik.containo.us
spec:
  group: traefik.containo.us
  scope: Namespaced
  names:
    kind: IngressRoute
    listKind: IngressRouteList
    plural: ingressroutes
    singular: ingressroute
  versions:
    - name: v1alpha1
      served: true
      storage: true
      schema:
        openAPIV3Schema:
          type: object
          description: IngressRoute is an Ingress CRD specification.
          required:
            - metadata
            - spec
          properties:
            apiVersion:
              type: string
              description: >-
                APIVersion defines the versioned schema of this representation of an object.
                Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values.
                More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
            kind:
              type: string
              description: >-
                Kind is a string value representing the REST resource this object represents.
                Servers may infer this from the endpoint the client submits requests to.
                Cannot be updated.
                In CamelCase.
                More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
            metadata:
              type: object
            spec:
              type: object
              description: IngressRouteSpec is a specification for a IngressRouteSpec resource.
              required:
                - routes
              properties:
                entryPoints:
                  type: array
                  items:
                    type: string
                routes:
                  type: array
                  items:
                    type: object
                    description: Route contains the set of routes.
                    required:
                      - kind
                      - match
                    properties:
                      kind:
                        type: string
                        enum:
                          - Rule
                      match:
                        type: string
                      middlewares:
                        type: array
                        items:
                          type: object
                          description: MiddlewareRef is a ref to the Middleware resources.
                          properties:
                            name:
                              type: string
                            namespace:
                              type: string
                          required:
                            - name
                      priority:
                        type: integer
                      services:
                        type: array
                        items:
                          type: object
                          description: Service defines an upstream to proxy traffic.
                          required:
                            - name
                          properties:
                            kind:
                              type: string
                              enum:
                                - Service
                                - TraefikService
                            name:
                              type: string
                              description: >-
                                Name is a reference to a Kubernetes Service object (for a load-balancer of servers),
                                or to a TraefikService object (service load-balancer, mirroring, etc).
                                The differentiation between the two is specified in the Kind field.
                            namespace:
                              type: string
                            passHostHeader:
                              type: boolean
                            port:
                              anyOf:
                                - type: integer
                                - type: string
                              x-kubernetes-int-or-string: true
                            responseForwarding:
                              type: object
                              description: ResponseForwarding holds configuration for the forward of the response.
                              properties:
                                flushInterval:
                                  type: string
                            scheme:
                              type: string
                            serversTransport:
                              type: string
                            sticky:
                              type: object
                              description: Sticky holds the sticky configuration.
                              properties:
                                cookie:
                                  type: object
                                  description: Cookie holds the sticky configuration based on cookie.
                                  properties:
                                    httpOnly:
                                      type: boolean
                                    name:
                                      type: string
                                    sameSite:
                                      type: string
                                    secure:
                                      type: boolean
                            strategy:
                              type: string
                            weight:
                              type: integer
                              description: >-
                                Weight should only be specified when Name references a TraefikService object (and to be precise, one that embeds a Weighted Round Robin).
                tls:
                  type: object
                  description: >-
                    TLS contains the TLS certificates configuration of the routes.
                    To enable Let's Encrypt, use an empty TLS struct, e.g. in YAML:
                      tls: {}       # inline format
                      tls:
                        secretName: # block format
                  properties:
                    certResolver:
                      type: string
                    domains:
                      type: array
                      items:
                        type: object
                        description: Domain holds a domain name with SANs.
                        properties:
                          main:
                            type: string
                          sans:
                            type: array
                            items:
                              type: string
                    options:
                      type: object
                      description: Options is a reference to a TLSOption, that specifies the parameters of the TLS connection.
                      required:
                        - name
                      properties:
                        name:
                          type: string
                        namespace:
                          type: string
                    secretName:
                      type: string
                      description: SecretName is the name of the referenced Kubernetes Secret to specify the certificate details.
                    store:
                      type: object
                      description: Store is a reference to a TLSStore, that specifies the parameters of the TLS store.
                      required:
                        - name
                      properties:
                        name:
                          type: string
                        namespace:
                          type: string
status:
  acceptedNames:
    kind: ""
    plural: ""
  conditions: []
  storedVersions: []
